unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const Captionstop = 'Stop';
      Captionstart = 'Alle Permut.';
      stopmoeglich =1000000; //1000 000
      Zwoelftoene ='abcdefghijkl';
var
  Form1: TForm1;
  zaehl: integer;
  intarr:array of integer;
  stop: boolean;

implementation

{$R *.DFM}


procedure ordnechar(var s:string; k,n:integer); //bubblesort
  var i,j:integer;
      x:char;
begin
  for i := k to n do for j := i+1 to n do
    if s[i] > s[j] then Begin
      x := s[i];
      s[i] := s[j];
      s[j] := x
    End;
end;

procedure tausche(var s:string; const k:integer);
  var  i: integer;
       c: char;
begin
    ordnechar(s,k,length(s));
    //Tausche mit dem kleinsten aus s[k] s[k+1] ... s[n] das grer als s[k-1] ist
    c := s[k-1];
    for i := k to length(s) do
      if c < s[i] then Begin
        s[k-1] := s[i];
        s[i] := c; //getauscht!
        break;
      End;
    ordnechar(s,k,length(s));
end;

procedure naechstePermutation(var s: string);
  var k:integer; //z.B. s='12543' k=3
begin
  k:= length(s);
  while (s[k] < s[k-1]) and (k > 0) do dec(k);
  if k =1 then s := '' else
  //Tausch s[k-1] mit dem kleinste Element aus s[k], s[k+1] ...
  //Rest alphabetisch sortieren
  Tausche(s,k);
end;

//Bemerkung zur Zwlftontechnik:
//Mit s := 'abcdefghijkl' (Die 12 Tne der chromatischen Tonleiter) erzeugt das Programm alle 12 ! = 479 001 600 Zwlftonserien. Mit folgender Funktion kann man diejenigen Zwlftonserien mit lauter verschiedenen Intervallen aussortieren:
function serie(s:string):boolean; //=True: Alle Intervalle verschieden
    var k,j,n:integer;
  begin
    n := length(s); //hier n = 12
    //pu[1]   = |ord(s[2]) - ord(s[1])|
    //...
    //pu[n-1] = |ord(s[n]) - ord(s[n-1])|
    for k := 1 to n - 1 do
      intarr[k] := abs(ord(s[k+1]) - ord(s[k])); //11 Intervalle
    result := true;
    for k := 1 to n-1 do for j := k+1 to n-1 do
      if intarr[k] = intarr[j] then begin
      result := false;
      exit;
    End;
  end;

procedure Sternchenweg;
begin
  with form1.edit1 do
    while pos('*',text) > 0 do text := copy(text,1,length(text)-1);
end;

procedure abschluss(zaehl:integer);
begin
  Form1.memo1.Lines.Add('-------'#13#10+
    'Anzahl:'+intToStr(zaehl));
  if stop then form1.Memo1.lines.add('Abbruch!');
  Form1.button1.Caption := CaptionStart;
  Sternchenweg;
end;

procedure TForm1.Button1Click(Sender: TObject);
  var s, int, nr, leer, s_lesbar: string;
      k,n,ll: integer;
      original: array of char;
  function lesbar(const s: string): string;
       var i: integer;
    begin
      setlength(result,ll);
      for i := 1 to ll do result[i] := original[ord(s[i])];
    end;
begin
  if button1.Caption = CaptionStop then Begin
    stop := true;
    Abschluss(zaehl);
    exit;
  End else Begin
    button1.Caption := CaptionStop;
    stop := false;
  End;
  memo1.lines.clear;
  Sternchenweg;
  s := edit1.Text;
  if s = '' then Begin
    s := '12345';
    edit1.text := s;
  End;
  ll := length(s);
  setlength(original,ll + 1);
  for k := 1 to ll do original[k] := s[k];
  if sender = button1 then
    for k := 1 to length(s) do s[k] := char(k); // s ist von der Form "12345" ohne Wiederholungen
  setlength(intarr,length(s));
  leer := '';
  while length(leer) + length(s) < 12 do leer := leer + ' ';
  if sender = button2 then
    memo1.lines.add(
      'Es werden die Permutationen aussortiert,'#13#10+
      'die aus verschieden Intervallen bestehen.'#13#10+
      '(Bei zwlf Tnen erhlt man so Serien der Zwlftontechnik.)'#13#10+
      'Nr.      Permutation  Intervalle') else
  zaehl := 0;
  n := 0;
  repeat
    inc(n);
    if stop then exit;
    if n mod stopmoeglich =0 then Begin
      edit1.Text := edit1.text + '*';
      if length(edit1.text) > 40 then SternchenWeg;
      application.ProcessMessages;
    End;
    {Trick mit bereits gerechneten Elementen
    Nr.      Permutation  Intervalle
    36614981 albkcjdiehfg 11 10 9 8 7 6 5 4 3 2 1
    69637139 bjclakegfidh 8 7 9 11 10 6 2 1 3 5 4}
    if s = Zwoelftoene then Begin
      memo1.Lines.Add('36614981 albkcjdiehfg 11 10 9 8 7 6 5 4 3 2 1');
      zaehl := 1;
      n := 69637139;
      s := 'bjclakegfidh'
    End;
    if (sender = button1) then Begin
      s_lesbar := lesbar(s);
      if pos(s_lesbar,memo1.text) = 0 then BEgin
        inc(zaehl);
        memo1.Lines.Add(s_lesbar);
      ENd;
      application.ProcessMessages;
    End else if serie(s) then Begin
      inc(zaehl);
      int := '';
      for k := 1 to length(s) - 1 do
        int := int+' '+intToStr(abs(ord(s[k+1]) - ord(s[k]))); //Intervalle
      nr := IntToStr(n);
      while length(nr) < 9 do nr := nr + ' ';
      memo1.Lines.Add(nr+s+leer+int);
      application.ProcessMessages;
    End;
    naechstePermutation(s);
  until s = '';
  abschluss(zaehl);
end;



procedure TForm1.Button3Click(Sender: TObject);
begin
  edit1.text := Zwoelftoene;
  showmessage('Jetzt auf "Serie" klicken und eine Nacht warten!'#13#10+
   'Dann erhalten Sie alle 1304 Serien mit verschiedenen Intervallen.'#13#10+
    '(Pro '+intToStr(stopmoeglich)+' Permutationen erscheint ein "*".)');
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  stop := true;
end;

end.
